#include <xc.h>
#include <plib.h>
#include "vardef.h"
#include "functions.h"
#include "Uart.h"
//#include "HardwareProfile.h"

// DEVCFG3
// USERID = No Setting
#pragma config PMDL1WAY = OFF            // Peripheral Module Disable Configuration (Allow only one reconfiguration)
#pragma config IOL1WAY = OFF             // Peripheral Pin Select Configuration (Allow only one reconfiguration)
#pragma config FUSBIDIO = OFF            // USB USID USBȊO̗prƂ(OFF)
#pragma config FVBUSONIO = OFF           // USB VBUS ON Selection (Controlled by USB Module)

// DEVCFG2
#pragma config FPLLIDIV = DIV_5         // PLL Input Divider (2x Divider)
#pragma config FPLLMUL = MUL_20         // PLL Multiplier (20x Multiplier)
#pragma config UPLLIDIV = DIV_5         // USB PLL Input Divider (2x Divider)
#pragma config FPLLODIV = DIV_2     // PLL Output Divider: 80 / 2 = 40
#pragma config UPLLEN = OFF             // USB PLL Enable (Enabled)

// DEVCFG1
#pragma config FNOSC = PRIPLL           // Oscillator Selection Bits (Fast RC Osc with PLL)
#pragma config FSOSCEN = OFF            // Secondary Oscillator Enable (Disabled)
#pragma config IESO = OFF               // Internal/External Switch Over (Disabled)
#pragma config POSCMOD = HS             // Primary Oscillator Configuration (HS osc mode)
#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Disabled)
#pragma config FPBDIV = DIV_1           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/1)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable (Watchdog Timer is in Non-Window Mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (WDT Disabled (SWDTEN Bit Controls))
#pragma config FWDTWINSZ = WINSZ_25     // Watchdog Timer Window Size (Window Size is 25%)

// DEVCFG0
#pragma config JTAGEN = OFF             // JTAG Enable (JTAG Port Enabled)
#pragma config ICESEL = ICS_PGx3        // ICE/ICD Comm Channel Select (Communicate on PGEC1/PGED1)
#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Enabled)
#pragma config CP = OFF                 // Code Protect (Protection Disabled)

//---------------------- ϐCX^X̒`
#if 1
char    gIsRunning;
volatile DWORD     gnTimer2Cnt;
volatile int     gn100msCnt;
volatile int     gnAliveCnt; 
volatile DWORD gnLastCPlusT2Val;
int     gnTimer4Mode;
volatile int     gninjstoppreiod;
volatile int     gninjststartwait;
volatile int     gninjststartangle;
volatile int     gnignstoppreiod;
volatile int     gnignstartwait;
volatile int     gnignstartangle;
IDLEDATA gidledata;
unsigned char gadresult[ADSAMPLING_UNIT * 2][8];
volatile int     gidxadresult;
ALLTBL	gecudata;			// }bvf[^BFLUSḦ悩炱ɃRs[Ďg
volatile int     groundtime;         // 1]̎ԁA1/100~bP
volatile int     glastTDCtime;       // Ō̏㎀_łTMR5̒l
volatile char     gIsInputCycle;      // ݂zCTCNǂ
volatile int     gidxrpm;
volatile char    gnanglenow;
char     gCPlusOn;   
char    gOInjOn;            // ݁AIWiCWFN^[ON̏ꍇP
int     gnOinjstoppreiod;   // IWiCWFN^ ON->OFF܂ł̃^C
char	gOIgnOn;            // ݁AIWiIGNON̏ꍇ1
char    gOInjEnter;         // IWiCWFN^[2]ONɂȂƂ邩
char    gOIgnEnter;          // IWiIGN2]ONɂȂƂ邩
int     gnOignstoppreiod;   // IWiIGN ON->OFF܂ł̃^C
int		gac12Vresult;	
volatile int     gADOkayBank;	// ADϊĂoN 1 or 2, 0ȂAD
int     gErrorCode = EC_NOERROR;		// O[oG[R[h
UINT8	gIdxTbls[4][256];		// 臒lCfNXe[uB8rbglɑ΂CfNXۑBSB
SAVEDATA gsavedata;          //
volatile int gVaccumVal;
volatile int gWaitInterupt;  // ֎~INTԍ
volatile int gnLastBTDC;
volatile int gnAccelDelta;
volatile int gnKasokuAdd;
volatile int gnKasokuSubVal;    // gnKasokuAdd 0.1bɌZl
volatile int gnAccelPumpSpan;
int     gAccelVal;        
static int ledBlinkRatio = 4;
volatile int gerror = 0;
#endif

//------------------------------------------- ftHgf[^̃e[u
ALLTBL deftable __attribute__ ((space(prog), aligned(1024))) =
{
	{},
	{},	// VACCUM臒l
	{},	//2
	{}, //3
	{}, //4
	{155, 123, 94, 69, 51, 37, 27, 19, 14, 11, 8, 6, 5,	4, 3, 0},	// T[~X^臒l
	{}, //5
	{155, 123, 94, 69, 51, 37, 27, 19, 14, 11, 8, 6, 5,	4, 3, 0},
};

void InitializeSystem()
{
	UINT pbClk;
	pbClk =	SYSTEMConfigPerformance(GetSystemClock());
    INTEnableSystemMultiVectoredInt(); // Interrupt vectoring

	// AiO|[g͂
	TRISASET = (_PORTA_RA0_MASK | _PORTA_RA1_MASK | _PORTA_RA4_MASK);
	TRISBSET = (_TRISB_TRISB0_MASK | _TRISB_TRISB1_MASK |_TRISB_TRISB2_MASK | _TRISB_TRISB3_MASK | 
				_TRISB_TRISB4_MASK | _TRISB_TRISB5_MASK | _TRISB_TRISB11_MASK);
	// ̑o͂
	TRISBCLR = (_TRISB_TRISB7_MASK | _TRISB_TRISB8_MASK | _TRISB_TRISB9_MASK | _TRISB_TRISB10_MASK |
			    _TRISB_TRISB13_MASK | _TRISB_TRISB14_MASK | _TRISB_TRISB15_MASK);
	// UART@gpPINvAbvĂ݂
	CNPUBbits.CNPUB11 = 1;
	CNPUBbits.CNPUB14 = 1;

	// ɏo͂Itɂׂ̂ItɂĂ
	//LATB = 0;
	led1_off();
	INJ_off();
	IGN_off();
	MTR1_LO();
	MTR2_LO();
	
	// ϐ
	InitVars(); 

	// ADRo[^ZbgAbv
	ANSELA = 0x03;				// A0, A1̓AiO for sensor
	ANSELB = 0x0f;				// B0 - B3 AiOAfor sensor
	AD1CON2bits.CSCNA = 1;
	AD1CSSL = 0x3f;				// AN0 - AN5 ܂łUXL[hɂ
	AD1CON2bits.BUFM = 1;		// QoNobt@g
	AD1CON2bits.SMPI = 5;		// UTvO
	// 0.1msPʂŃTvOłΏ\ŁA6̂ 60ksps Ƃɂ 1 / 32 * (12 + 8) * 25ns
	AD1CON3bits.SAMC = 8;		// TAD = 8, 
	AD1CON3bits.ADCS = 3;		// 32  
	AD1CON1bits.ASAM = 1;		// TvO
	AD1CON1bits.SSRC = 7;		// gK
	AD1CON1bits.ON = 1;			// ADϊW[ON

	mAD1ClearIntFlag();
	mAD1SetIntPriority(1);		// Dx
	mAD1IntEnable(1);
	gidxadresult = 0;
	

	// NNpXM荞݂ŏ
    IC4R = 0x02;                   // ͊荞݂RB4ATC;
	//TRISBbits.TRISB8 = 0;			// vAbvĂBgKdŃtHgJvONŃRN^d
    mIC4ClearIntFlag();
    mIC4SetIntPriority(5);			// 
    mIC4IntEnable(1);
	//@I[vhCȂ̂ŁAONɂȂLowȂ̂ŁAFALLEDGE
	OpenCapture4(IC_ON | IC_FEDGE_FALL | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_SP_EVERY_EDGE);

	// IWĩCWFN^[ˊԊup
    IC1R = 0x02;                   // ͊荞݂RA4ATC;
	//TRISBbits.TRISB4 = 0;			// vAbv
    mIC1ClearIntFlag();
    mIC1SetIntPriority(4);			// 
    mIC1IntEnable(1);
	OpenCapture1(IC_ON | IC_FEDGE_FALL | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_SP_EVERY_EDGE);
	
	// IWĩCOiC^Ԋup
    IC3R = 0x01;                   // ͊荞݂RB5ATC;
	//TRISBbits.TRISB5 = 0;			// vAbv
    mIC3ClearIntFlag();
    mIC3SetIntPriority(4);			// 
    mIC3IntEnable(1);
	OpenCapture3(IC_ON | IC_FEDGE_FALL | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_SP_EVERY_EDGE);
	
	//@GW쒆Timer2荞ݖɉZϐ̓NNpX̃X^[gn_
	// Zbg邽߂ɁAϐlȏ̏ꍇ͒~ĂƔfB
	OpenTimer2( T2_ON | T2_PS_1_256 | T2_SOURCE_INT, WAIT100MS_SYSCLK);	// 0.1bԊuŊ荞ޒx
	mT2SetIntPriority(6);	//̊荞݂ƂDx
	mT2ClearIntFlag();
	mT2IntEnable(1);

	OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, 0xffff);	// ͂PVbg^C}[Ȃ̂PR̒l͓sxύX
	mT4SetIntPriority(5);

	OpenTimer1( T1_ON | T1_PS_1_256 | T1_SOURCE_INT, 0xffff);	// PVbg^C}[A듮h~pɊ荞݋֎~Ԃݒ
	mT1SetIntPriority(3);

	
	//UARTI[v
	UartInit(pbClk);
	
	// [U[f[^[h
	{
		char	IsDefault = 0;
		memcpy(&gsavedata, ((void *)UDATA_FLASH_ADDRESS), sizeof(SAVEDATA));
		if (gsavedata.verifysign1 == 0xffffffff && gsavedata.verifysign2 == 0xffffffff)
		{
			// ftHgo[[h
			gsavedata.verifysign1 = 0;
			gsavedata.verifysign2 = 0;
			gsavedata.defIgnSpan = 640;
			gsavedata.defInjSpan = 400;
			gsavedata.ncurrent = 0;
			gsavedata.defBTDCFireVal = 200;
			gsavedata.naccelmin = 0;
			gsavedata.naccelmax = 0x3ff;
			gsavedata.IsUseAccelPump = 0;
			gsavedata.nAccelPumpSpan = 30;
			gsavedata.IsTunnelMode = 1;
			UpdateUdata(&gsavedata);
			IsDefault = 1;
		}
		else
		{
			if(gsavedata.ncurrent < 0 || gsavedata.ncurrent > 1)
				gsavedata.ncurrent = 0;
		}

		// ecue[u[h
		if(IsDefault)								// ftHglݒ
		{
			int		i;
			short	*parray = (short *)&gecudata.TBL02_data[0][0];
			char	*pcarray = (char *)&gecudata.TBL03_data[0][0];
			for( i = 0 ; i < sizeof(gecudata.TBL02_data) / sizeof(short); i++)
				parray[i] = 1000;
			for( i = 0 ; i < sizeof(gecudata.TBL03_data) ; i++)
				pcarray[i] = 0;
			parray = (short *)&gecudata.TBL09_data[0];
			for( i = 0 ; i < sizeof(gecudata.TBL09_data) / sizeof(short); i++)
				parray[i] = 1000;
			UpdateTable(0, &gecudata);
		}
		else
			memcpy(&gecudata, ((PALLTBL)TBL01_FLASH_ADDRESS  + gsavedata.ncurrent), sizeof(ALLTBL) );
		
		// 臒l̃CfNX쐬
		RemakeThresholdsIdx();
	}
	
}

//-------------------------------------  Onh
void _general_exception_handler( unsigned long ulCause, unsigned long ulStatus )
{
	/* This overrides the definition provided by the kernel.  Other exceptions 
	should be handled here. */
	//SoftReset();  
	if(ledBlinkRatio > 0)
		ledBlinkRatio--; 
	
	while(1)
	{
		DelayMs(100);
			led1_on();
		DelayMs(100);
			led1_off();
	}
	
}


void main()
{
	// 
	InitializeSystem();

	// C͒ʐMvZX
	while(1)
	{
//		if((gn100msCnt & 7) < ledBlinkRatio) 
//			led1_on();
//		else
//			led1_off();
		
		// G[ffōs
		// ʐMvZX
		if(isRXINT())
		{
			CommProcess();
			RXINT_Clear();
		}
	}
}
